{{ $currentPage := . }}
{{ $pages := .Page.Pages }}

{{ $groupedPages := dict }}

{{ range $pages }}
    {{ $category := .Params.category | default "Uncategorized" }}
    {{ $subcategory := .Params.subcategory | default "General" }}

    {{ $categoryDict := index $groupedPages $category | default dict }}
    {{ $subcategoryList := index $categoryDict $subcategory | default slice }}

    {{ $updatedSubcategoryList := $subcategoryList | append . }}
    {{ $updatedCategoryDict := merge $categoryDict (dict $subcategory $updatedSubcategoryList) }}
    {{ $groupedPages = merge $groupedPages (dict $category $updatedCategoryDict) }}
{{ end }}

<div class="grouped-pages">
    {{ range $category, $subcategories := $groupedPages }}
        <h2>{{ $category }}</h2>
        {{ $subcategoryCount := len $subcategories }}
        {{ if or (gt $subcategoryCount 1) (index $subcategories "General" | not) }}
            {{ range $subcategory, $pages := $subcategories }}
                <h3>{{ $subcategory }}</h3>
                <ul>
                    {{ range $pages }}
                        <li><a href="{{ .RelPermalink }}">{{ .Title }}</a></li>
                    {{ end }}
                </ul>
            {{ end }}
        {{ else }}
            <ul>
                {{ range (index $subcategories "General") }}
                    <li><a href="{{ .RelPermalink }}">{{ .Title }}</a></li>
                {{ end }}
            </ul>
        {{ end }}
    {{ end }}
</div>
